Index: trunk/src/emx/include/features.h
===================================================================
--- trunk/src/emx/include/features.h	(revision 1648)
+++ trunk/src/emx/include/features.h	(revision 1649)
@@ -11,4 +11,5 @@
  * @changed bird: Check if stuff is defined before accessing it in #if. Stops -Wundef
  *                from bitching.
+ * @changed bird: don't test on __EMX__ - RC & mozilla.
  */
 
@@ -117,7 +118,5 @@
 #undef	__FAVOR_BSD
 #undef	__KERNEL_STRICT_NAMES
-#ifdef __EMX__                          /* bird */
 #undef  __USE_EMX                       /* bird */
-#endif                                  /* bird */
 
 /* Suppress kernel-name space pollution unless user expressedly asks
@@ -144,5 +143,5 @@
 # define _ISOC99_SOURCE	1
 /* bird: sorry, but this isn't causing huge exclusions for BSD or EMX headers. */
-#ifndef __EMX__                         /* bird */
+#if 0 /*ndef __EMX__*/                  /* bird */
 # undef  _POSIX_SOURCE
 # define _POSIX_SOURCE	1
@@ -158,5 +157,5 @@
 # define _XOPEN_SOURCE_EXTENDED	1
 # undef	 _LARGEFILE64_SOURCE
-#ifndef __EMX__ /* bird */
+#if 0 /*def __EMX__*/ /* bird */
 # define _LARGEFILE64_SOURCE	1
 #endif          /* bird */
@@ -165,8 +164,8 @@
 # undef  _SVID_SOURCE
 # define _SVID_SOURCE	1
-# ifdef __EMX__
-#  define _EMX_SOURCE   1
-# endif
-#endif
+# if 1 /*def __EMX__ */                 /* bird */
+#  define _EMX_SOURCE   1               /* bird */
+# endif                                 /* bird */
+# endif
 
 /* If nothing (other than _GNU_SOURCE) is defined,
@@ -189,5 +188,5 @@
 #endif
 
-#ifndef __EMX__ /* bird: this messes up lot's of EMX legacy declarations. */
+#if 0 /*ndef __EMX__*/ /* bird: this messes up lot's of EMX legacy declarations. */
 /* If none of the ANSI/POSIX macros are defined, use POSIX.1 and POSIX.2
    (and IEEE Std 1003.1b-1993 unless _XOPEN_SOURCE is defined).  */
@@ -242,5 +241,5 @@
 #endif
 
-#ifndef __EMX__ /* bird */
+#if 0 /*ndef __EMX__*/ /* bird */
 #ifdef _LARGEFILE64_SOURCE
 # define __USE_LARGEFILE64	1
@@ -248,5 +247,5 @@
 #endif /* bird */
 
-#ifndef __EMX__ /* bird */
+#if 0 /*ndef __EMX__*/ /* bird */
 #if defined _FILE_OFFSET_BITS && _FILE_OFFSET_BITS == 64
 # define __USE_FILE_OFFSET64	1
@@ -263,5 +262,5 @@
 # define __USE_BSD	1
 /* bird: __USE_BSD == __BSD_VISIBLE, make sure it's defined. */
-# ifdef __EMX__
+# if 1 /*def __EMX__ */
 #  undef __BSD_VISIBLE
 #  define __BSD_VISIBLE  1
@@ -278,5 +277,5 @@
 #endif
 
-#if defined(__EMX__) && defined(_EMX_SOURCE) /* bird */
+#if defined(_EMX_SOURCE)                /* bird */
 # define __USE_EMX      1               /* bird */
 #endif                                  /* bird */
@@ -293,5 +292,5 @@
 #define __STDC_ISO_10646__		200009L
 
-#ifndef __EMX__ /*bird: we're not GLIBC */
+#if 0 /*ndef __EMX__*/ /*bird: we're not GLIBC */
 /* This macro indicates that the installed library is the GNU C Library.
    For historic reasons the value now is 6 and this will stay from now
@@ -344,5 +343,5 @@
 # if defined __USE_FILE_OFFSET64 && !defined __REDIRECT
 #  define __USE_LARGEFILE	1
-#ifndef __EMX__ /* bird */
+#if 0 /*ndef __EMX__*/ /* bird */
 #  define __USE_LARGEFILE64	1
 #endif          /* bird */
@@ -358,5 +357,5 @@
 
 
-#ifndef __EMX__ /* bird */
+#if 0 /*ndef __EMX__*/ /* bird */
 /* This is here only because every header file already includes this one.
    Get the definitions of all the appropriate `__stub_FUNCTION' symbols.
Index: trunk/src/emx/include/sys/gnu/cdefs.h
===================================================================
--- trunk/src/emx/include/sys/gnu/cdefs.h	(revision 1648)
+++ trunk/src/emx/include/sys/gnu/cdefs.h	(revision 1649)
@@ -20,4 +20,5 @@
  * GLIBC v2.3.2
  * @changed bird: #ifndef'ed out a few clashes with the BSD cdefs.h.
+ * @changed bird: Workaround for RC & mozilla.
  */
 
@@ -41,5 +42,5 @@
 #undef	__PMT
 
-#ifdef __GNUC__
+#if defined __GNUC__ || defined RC_INVOKED /* bird: RC hacks */
 
 /* GCC can always grok prototypes.  For C++ programs we add throw()